Page MenuHomeFreeBSD

kboot: Add MK_LOADER_KBOOT
ClosedPublic

Authored by imp on Dec 16 2021, 4:59 PM.

Details

Summary

Control building of KBOOT same as we do for uboot.

Sponsored by: Netflix

Test Plan

First of a series of commit to make kboot MI with and MD component.

Diff Detail

Repository
rG FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

imp requested review of this revision.Dec 16 2021, 4:59 PM
This revision is now accepted and ready to land.Dec 16 2021, 5:04 PM
luporl requested changes to this revision.Dec 22 2021, 12:48 PM
luporl added inline comments.
share/mk/src.opts.mk
315

This will break powerpc64le builds, that currently can't build kboot.

So this line should probably be something like:

.if ${__T} != "powerpc64"

Another option is to create a kboot/ldscript.powerpcle file and adjust the Makefile to use it instead, when on powerpc64le.
The contents of this file would be almost identical to kboot/ldscript.powerpc, just replacing "powerpc" occurrences by "powerpcle".

I've tested this change and it produces a "working" kboot binary, which can be useful to experiment with on Petitboot, on POWER8/POWER9 machines, now that MK_LOADER_FORCE_LE is gone. This "working" binary is able to start and most of loader's commands work, but I was unable to load a kernel with it (segfaults when trying to list a partition).

This revision now requires changes to proceed.Dec 22 2021, 12:48 PM
This revision was not accepted when it landed; it landed in state Needs Review.Dec 30 2021, 11:32 PM
This revision was automatically updated to reflect the committed changes.